"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs-extra"));
const path = __importStar(require("path"));
class ProjectScanner {
    static scanProject(entryPointPath) {
        return this.scanDirectory(path.resolve(entryPointPath));
    }
    static filterFiles(filePaths, fileExtension) {
        return filePaths.filter(filePath => filePath.fileInformation.ext.includes(fileExtension));
    }
    static isDirectory(filePath) {
        const stats = fs.lstatSync(filePath);
        return stats.isDirectory();
    }
    static scanDirectory(directoryPath) {
        let filePaths = [];
        let filesInDir = fs.readdirSync(directoryPath);
        filesInDir = filesInDir.map(file => directoryPath + "/" + file);
        filesInDir.forEach(filePath => {
            if (ProjectScanner.isDirectory(filePath)) {
                filePaths = filePaths.concat(this.scanDirectory(filePath));
            }
            else {
                filePaths.push({
                    fileInformation: path.parse(filePath),
                    filePath
                });
            }
        });
        return filePaths;
    }
}
exports.ProjectScanner = ProjectScanner;
//# sourceMappingURL=projectScanner.js.map